#!/bin/sh
#
# chkconfig: S 38 0
#
# Sets the hostname and apache header to the serial number of the device
# prepending 'spx-hmp-' to the hostname

case "$1" in
    start|restart)
    if [ ! -e /etc/hostname -o ! -e /etc/apache/conf.d/30-spxserial.conf ]; then
	sn="$(sed -e '/^Serial\s\+/{s,.*:\s\+0000,,p};d' /proc/cpuinfo)"
	if [ $? -ne 0 ]; then
	    echo "failed recovering serial number from /proc/cpuinfo"
	    exit 1
	fi
    else
	exit 0
    fi
    if [ -z "$sn" -o "$sn" = "000000000000" ]; then
	echo -n "No serial number"
	exit 0
    fi
    if [ ! -e /etc/hostname ]; then
	echo -n "Setting the hostname to serial number"
	echo spx-hmp-$sn> /etc/hostname
	echo "."
    fi
    if [ ! -e /etc/apache/conf.d/30-spxserial.conf ]; then
	echo -n "Setting apache httpd serial number header"
	sed -e "s/@@serial@@/$sn/;" /etc/apache/conf.d/30-spxserial.conf.tmpl > /etc/apache/conf.d/30-spxserial.conf
	echo "."
    fi
    ;;
    stop|reload|force-reload)
    ;;
esac



