<?php
$title="Security"; 
include ("prolog.php");

function crypt_apr1_md5($plainpasswd, $salt="") {
    
    if ($salt=="")
    	$salt = substr(str_shuffle("abcdefghijklmnopqrstuvwxyz0123456789"), 0, 8);
    else 
    	$salt = substr($salt,6,8);
 
    $len = strlen($plainpasswd);
    $text = $plainpasswd.'$apr1$'.$salt;
    $bin = pack("H32", md5($plainpasswd.$salt.$plainpasswd));
    for($i = $len; $i > 0; $i -= 16) { $text .= substr($bin, 0, min(16, $i)); }
    for($i = $len; $i > 0; $i >>= 1) { $text .= ($i & 1) ? chr(0) : $plainpasswd{0}; }
    $bin = pack("H32", md5($text));
    for($i = 0; $i < 1000; $i++) {
        $new = ($i & 1) ? $plainpasswd : $bin;
        if ($i % 3) $new .= $salt;
        if ($i % 7) $new .= $plainpasswd;
        $new .= ($i & 1) ? $bin : $plainpasswd;
        $bin = pack("H32", md5($new));
    }
    $tmp="";
    for ($i = 0; $i < 5; $i++) {
        $k = $i + 6;
        $j = $i + 12;
        if ($j == 16) $j = 5;
        $tmp = $bin[$i].$bin[$k].$bin[$j].$tmp;
    }
    $tmp = chr(0).chr(0).$bin[11].$tmp;
    $tmp = strtr(strrev(substr(base64_encode($tmp), 2)),
    "ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz0123456789+/",
    "./0123456789ABCDEFGHIJKLMNOPQRSTUVWXYZabcdefghijklmnopqrstuvwxyz");
    return "$"."apr1"."$".$salt."$".$tmp;
}

function getUsers($passfile){
	global $use_digest;
	$users=array();
	if (file_exists($passfile)){
		$passwords=file_get_contents($passfile);
		$passwords=explode("\n",$passwords);
		$users=array();
		foreach ($passwords as $line){
			if ($use_digest){
				if (ereg("(.*)(:)(.*)(:)(.*)", $line, $passelements)){
					$users[]=array('user'=>$passelements[1], 'pass'=>$passelements[5], 'digest'=>$passelements[3]);
				}
			}else{
				if (ereg("(.*)(:)(.*)", $line, $passelements) && strpos($passelements[1],":")==false){
					$users[]=array('user'=>$passelements[1], 'pass'=>$passelements[3]);
				}
			}
		}
	}
	return $users;
}

function saveUsers($passfile,$users){
	global $use_digest;
	global $spxpass_url;
	global $spxpass_user;
	
	$xlinkNS = 'http://www.w3.org/1999/xlink';
	$pass_conf_name="/srv/raperca/spxpasswd.xml";
	$pass_config = new DOMDocument;
	if ( file_exists($pass_conf_name) )
		$pass_config->loadXML(file_get_contents($pass_conf_name));
	$parent=$pass_config->getElementsByTagName('credits');
	if ($parent->length<1) $parent=$pass_config->appendChild($pass_config->createElement('credits'));
	else $parent=$parent->item(0);
	
	$str="";
	//print_r($users);
	foreach($users as $user){
		if ( $user ){
			if ($use_digest){
				$str.=$user['user'].":".$user['digest'].":".$user['pass']."\n";	
			}else{
				$str.=$user['user'].":".$user['pass']."\n";
			}
			if ( $user['user']!="admin" &&
				 $spxpass_url[$user['user']] &&
			     $spxpass_user[$user['digest']] == $user['user']
			     && isset($user['clearpass']) )
			{
			     $id=preg_replace("/\s/m",".",$user['digest']);
			     $cred=$pass_config->getElementById($id);
			     if (!$cred) {
				  $cred=$pass_config->createElement('creditentials');
				  $parent->appendChild($cred);
			     } 
			     $cred->setAttribute("username", $user['user']);
			     $cred->setAttribute("password", $user['clearpass']);
			     $cred->setAttribute("realm", $user['digest']);
			     $cred->setAttributeNS($xlinkNS,"xlink:href",
						   $spxpass_url[$user['user']]);
			     $cred->setAttribute("xml:id", $id);
			}
		}
	}
	
	save_file($passfile,$str);
	
	// save data in the XML file also
	save_file($pass_conf_name,$pass_config->saveXML(), true);
	
	
}
function getUser($users, $name, $digest, &$idx=0){
	$curuser=false;
	foreach($users as $idx=>$user){
		if ($user['user']==$name && (!isset($user['digest']) || $user['digest']==$digest) ) {
			$curuser=$user;
			break;
		}
	}
	return $curuser;
}
function addUser(&$users, $name, $digest, $oldpass, $newpass){
	global $use_digest;
	// check that the old password match
	$idx=-1;
	$curuser=getUser($users,$name,$digest,$idx);
	$setpass="";
	if ( !($oldpass===false) && $curuser){
		$setpass=$curuser['pass'];
		if ($use_digest){
			$p=md5($curuser['user'].":".$curuser['digest'].":".$oldpass);
		}else{
			$p=crypt_apr1_md5($oldpass,$setpass);
		}
	}
	if (isset($p) && $p!=$setpass){
	     echo "<h2>Error</h2>Old password is incorrect, please verify<br/><br/>\n";
		return false;
	}else{
		if ($newpass==""){
			if ($idx>=0)
				$users[$idx]=false;
		}else{
			if (!$curuser){
				$curuser['user']=$name;
				$curuser['digest']=$digest;
				$idx=-1;
			} 
			$curuser['clearpass']=$newpass;
			if ($use_digest){
				$curuser['pass']=md5($curuser['user'].":".$curuser['digest'].":".$newpass);
			}else{
				$curuser['pass']=crypt_apr1_md5($newpass); 
			}
			
			if ($idx>=0)
				$users[$idx]=$curuser;
			else
				$users[]=$curuser;
		}
	}
	return true;
}

include 'safe-data.php';

function setAccess($protfile){
    save_symlink(basename($protfile).".tmpl",$protfile);
    global $needreload;
    $needreload = TRUE;
}
function clearAccess($protfile){
	if (file_exists($protfile)){
		unlink($protfile);
		exec('sync'); // make sure data is commited before returning
		global $needreload;
		$needreload = TRUE;
	}
}

$use_digest=true; # WARNING: only digesty auth supported by protection files!
$admin='admin';
$passfile="/etc/raperca/htpasswd"; # referred in pro files directly!
$admprotfile="/etc/apache/conf.d/95-raperca-adm-prot.conf";
$contprotfile="/etc/apache/conf.d/95-raperca-cont-prot.conf";
$logprotfile="/etc/apache/conf.d/95-raperca-log-prot.conf";

# WARNING: cannot change $admindigest since the name is also hardcoded
# in the failsafe (a.k.a. recovery, diagnostics) mode.
$admindigest="Administrative Area";
$contentdigest="Content Area";
$logdigest="Monitoring Area";
$spxpass_url=array('content' => 'http://localhost:81/',
		   'monitoring' => 'http://localhost/',
		   'admin' => 'http://localhost/');
$spxpass_user=array($contentdigest => 'content',
		     $logdigest => 'monitoring',
		     $admindigest => 'admin');

$needreload=FALSE;


// get the passwords and users:
$users=getUsers($passfile);

if (isset($_POST['admin_paswrd'])){
	if (isset($_POST['old']) && isset($_POST['new1']) && ($_POST['new1'] || $_POST['old'])){
		if ($_POST['new1']!=$_POST['new2']){
			echo "<h2>Error</h2>New password incorrectly typed, please verify your password<br/><br/>";
		}else{
			if (addUser($users, $admin, $admindigest, $_POST['old'], $_POST['new1'])){
				addUser($users, $admin, $contentdigest, false, $_POST['new1']);
				addUser($users, $admin, $logdigest, false, $_POST['new1']);
				saveUsers($passfile,$users);
				if ($_POST['new1'] == ""){
					clearAccess($admprotfile);
					if ( ! setSafeModeData("htpasswd", FALSE) )
		    			echo "<h2>Error</h2>Failed clearing admin password for recovery console, please set again.<br/><br/>";			
				}else{
					setAccess($admprotfile);
					if ( ! setSafeModeData("htpasswd", $passfile ) )
		    			echo "<h2>Error</h2>Failed setting password for recovery console, please set again.<br/><br/>";						
				}
			}
		}
	}
}elseif (isset($_POST['content_paswrd'])){
	
	if ($_POST['new1']){
		$user=getUser($users,$_POST['user'],$contentdigest);
	} 
	if ($_POST['new1']!=$_POST['new2']){
		echo "<h2>Error</h2>Password incorrectly typed, please verify your password<br/><br/>";
	}else{
		if ($_POST['new1']!="" && addUser($users, $_POST['user'], $contentdigest, false, $_POST['new1'])){
			saveUsers($passfile,$users);
		}				
	}
	if ($_POST['use_paswrd']){
		setAccess($contprotfile);
	}else{
		clearAccess($contprotfile);
	}
	
}elseif (isset($_POST['log_paswrd'])){
	
	if ($_POST['new1']){
		$user=getUser($users,$_POST['user'],$contentdigest);
	} 
	if ($_POST['new1']!=$_POST['new2']){
		echo "<h2>Error</h2>Password incorrectly typed, please verify your password<br/><br/>";
	}else{
		if ($_POST['new1']!="" && addUser($users, $_POST['user'], $logdigest, false, $_POST['new1'])){
			saveUsers($passfile,$users);
		}				
	}				
	if ($_POST['use_paswrd']){
		setAccess($logprotfile);
	}else{
		clearAccess($logprotfile);
	}
	
}

clearstatcache();
$hasadminpass = file_exists($admprotfile);

if (file_exists($contprotfile)) {
	$hascontentpass=true; 
	$contentpasson="checked='checked'"; 
	$contentpassoff="";	
} else {
	$contentpasson=""; 
	$contentpassoff="checked='checked'";
}

if (file_exists($logprotfile)) {
	$haslogpass=true; 
	$logpasson="checked='checked'"; 
	$logpassoff="";	
} else {
	$logpasson=""; 
	$logpassoff="checked='checked'";
}

if ($needreload) {
    echo "<h2>Status</h2>\n";
    echo "<p>The security change will be effective in a few seconds.</p>\n";
}

?>
<h2>Administrative Server</h2>
<br/>
<form action="accessconfig.php" method="post">

<?php
if (!$hasadminpass) echo "<p style='color: red'><strong>Warning:</strong> Administrative area is not password protected.<br/></p>\n";
?>
<table>
<tr><td>User name : </td><td><input type='text' name='user' value='admin' disabled='disabled' /><input type='hidden' name='user' value='admin' /></td></tr>

<tr><td>Old password : </td><td><input type='password' name='old'/></td></tr>
<tr><td>New password : </td><td><input type='password' name='new1'/></td></tr>
<tr><td>Confirm password : </td><td><input type='password' name='new2'/></td></tr>
</table>
<input type="submit" name='admin_paswrd' value="Apply" />
<br/>
</form>
<br/>

<h2>Content Server</h2>
<br/>
<form action="accessconfig.php" method="post">

Password protected : 
<input type='radio' name='use_paswrd' <?php echo $contentpasson; ?> value='1' />yes
<input type='radio' name='use_paswrd' <?php echo $contentpassoff; ?> value='0' />no
<br/><br/>

<table>
<tr><td>User name : </td><td><input type='text' name='user' value='content' disabled='disabled' /><input type='hidden' name='user' value='content' /></td></tr>

<tr><td>Password : </td><td><input type='password' name='new1'/></td></tr>
<tr><td>Confirm password : </td><td><input type='password' name='new2'/></td></tr>
</table>
<input type="submit" name="content_paswrd" value="Apply" />
<br/>
</form>
<br/>

<h2>Monitoring</h2>
<br/>
<form action="accessconfig.php" method="post">

Password protected : 
<input type='radio' name='use_paswrd' <?php echo $logpasson; ?> value='1' />yes
<input type='radio' name='use_paswrd' <?php echo $logpassoff; ?> value='0' />no
<br/><br/>

<table>
<tr><td>User name : </td><td><input type='text' name='user' value='monitoring' disabled='disabled' /><input type='hidden' name='user' value='monitoring' /></td></tr>

<tr><td>Password : </td><td><input type='password' name='new1'/></td></tr>
<tr><td>Confirm password : </td><td><input type='password' name='new2'/></td></tr>
</table>
<input type="submit" name="log_paswrd" value="Apply" />
<br/>
</form>
<br/>
<?php
include "final.php";
if ($needreload) {
    # Push everything to http server before reloading the server's config
    ob_flush();
    flush();
    # This must be at the very end, otherwise apache graceful restart
    # may still close the connection to the FastCGI server process running
    # this script.
    exec('/etc/init.d/apache reload < /dev/null > /dev/null 2> /dev/null &');
}
?>
