<?php
/*
 * Created on 6 Aug 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */
$title="Serial Port"; 
include ("prolog.php");
 
 
$BaudRatesSet= array( 110, 300, 600, 1200, 2400, 4800, 9600, 14400, 19200, 38400, 57600, 115200, 128000, 256000 );
$paritySet=array("none", "even", "odd");
$flowControlSet=array("none", "XonXoff", "RTS/CTS", "RS485");
$byteSizeSet=array("7", "8");
$stopBitsSet=array("0", "1");

$confpathsys="/usr/share/raperca/comportfsm/";
$confpathusr=realpath("../comportfsm");
if ($confpathusr!=false) {
    $confpathusr .= "/";

    if (array_key_exists("new_file",$_FILES)){
	
	if ($_FILES["new_file"]["error"]>0 && $_FILES["new_file"]["name"]){
	     echo "Error: ", htmlspecialchars($_FILES["new_file"]["error"]), " while uploading: ", htmlspecialchars($_FILES["new_file"]["name"]), "<br />";
	}else {
		$ext=pathinfo($_FILES["new_file"]["name"]);
		if (strcasecmp("fsm",$ext["extension"])==0){
			move_uploaded_file($_FILES["new_file"]["tmp_name"],$confpathusr.$_FILES["new_file"]["name"]);
		}else{
		     echo "Error: ", htmlspecialchars($_FILES["new_file"]["name"]), " is not an fsm file<br />";
		}
	}
    }
} else {
    echo "<h2>Error</h2>\n";
    echo "<p>Local folder for comport files does not exist.</p>\n";
}

$filelist1=scandir($confpathsys);
$filelist=array("[disabled]" => "[disabled]");
foreach ($filelist1 as $file){
	if ($file!="." && $file!="..") $filelist["[sys] ".basename($file,".fsm")]=$confpathsys.$file;
}
if ($confpathusr!=false) {
    $filelist2=scandir($confpathusr);
    foreach ($filelist2 as $file){
	if ($file!="." && $file!="..") $filelist[basename($file,".fsm")]=$confpathusr.$file;
    }
}


// read the current settings:
$name="default";
$href="[disabled]";
$portNumber=1;
$baudRate=9600;
$byteSize=8;
$stopBits=1;
$flowControl="none";
$parity="none";
$onTime="00:00";
$offTime="24:00";
$config_name="/srv/raperca/spxconfig.xml";

 
$config = new DOMDocument;
$config->loadXML(file_get_contents($config_name));
$doShutdown=false;
if (isset($_POST['update'])){
	foreach($_POST as $key => $val)
		${$key}=$val;
	
	$ComPorts=$config->getElementsByTagName("serialPort");
	$deleteList=array();
	foreach($ComPorts as $item) $deleteList[]=$item;
	foreach($deleteList as $item) $item->parentNode->removeChild($item);
	if ($href!="[disabled]"){
		// create a new node
		$node=$config->createElement("serialPort");
		$player=$config->documentElement->getElementsByTagName("player");
		if ($player->length>0) {
			$node=$player->item(0)->appendChild($node);
		}else{
			$node=$config->documentElement->appendChild($node);
			echo "Warning no player tag found in the config, cannot add SerialPort tag.<br/>";
		}
	
		$node->setAttribute("href",$href);
		$node->setAttribute("portNumber",$portNumber);
		if (isset($comSettings)){
			$node->setAttribute("baudRate",$baudRate);
			$node->setAttribute("byteSize",$byteSize);
			$node->setAttribute("stopBits",$stopBits);
			$node->setAttribute("flowControl","none");
			$node->setAttribute("parity",$parity);
		}
		if (isset($onTime) && isset($offTime) && isset($monPower)){
			$node->setAttribute("onTime",$onTime);
			$node->setAttribute("offTime",$offTime);
		}
		$node->setAttribute("logIO",0);
		
		// checking silent mode:
		$stderr='';
		$status='';
		exec('fw_printenv silent 2>&1',$stderr,$status);
		if ($stderr[0]=="silent=no"){
			exec('fw_setenv silent 2>&1',$stderr,$status);
			$doShutdown=true;
			if ($status!=0) echo "Update of the silent mode for serial port failed. COM port might not work as expected.<br/>";
			
		}
	}
	if (save_file($config_name,$config->saveXML(), true))
		$doShutdown=true;
}else{
	$ComPorts=$config->getElementsByTagName("serialPort");
	if ($ComPorts->length>0){
		$isCOMPortEnabled=true;
		$ComPorts=$ComPorts->item(0);
		if ($ComPorts->hasAttribute("href")) $href=$ComPorts->getAttribute("href");
		if ($ComPorts->hasAttribute("portNumber")) $portNumber=$ComPorts->getAttribute("portNumber");
		
		if ($ComPorts->hasAttribute("baudRate")) { $baudRate=$ComPorts->getAttribute("baudRate"); $comSettings=true;}
		if ($ComPorts->hasAttribute("byteSize")) { $byteSize=$ComPorts->getAttribute("byteSize"); $comSettings=true;}
		if ($ComPorts->hasAttribute("stopBits")) { $stopBits=$ComPorts->getAttribute("stopBits"); $comSettings=true;}
		if ($ComPorts->hasAttribute("flowControl")) { $flowControl=$ComPorts->getAttribute("flowControl"); $comSettings=true;}
		if ($ComPorts->hasAttribute("parity")) { $parity=$ComPorts->getAttribute("parity"); $comSettings=true;}
		
		if ($ComPorts->hasAttribute("onTime") && $ComPorts->hasAttribute("offTime")) {
			$onTime=$ComPorts->getAttribute("onTime");
			$offTime=$ComPorts->getAttribute("offTime");
		}
	}
}	

if ($doShutdown){
	shutdown("serial port config change");
} else {
$disableCOMFields="";
if ($href=="[disabled]")	$disableCOMFields="disabled='disabled' ";
?>
<script type="text/javascript">
<!--
function enableCOMPortSettings()
{
	var selectFile=document.getElementById("COMPortFileSelect");
	var enablePower=document.getElementById("ControlMonPower");
	var enableSettings=document.getElementById("ControlCOMPortSettings");

	document.getElementsByName("monPower")[0].disabled=(selectFile.selectedIndex==0 );
	document.getElementsByName("onTime")[0].disabled=(selectFile.selectedIndex==0 || !enablePower.checked);
	document.getElementsByName("offTime")[0].disabled=(selectFile.selectedIndex==0 || !enablePower.checked);
	
	document.getElementsByName("comSettings")[0].disabled=(selectFile.selectedIndex==0);
	document.getElementsByName("baudRate")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("byteSize")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("parity")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("stopBits")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
	document.getElementsByName("flowControl")[0].disabled=(selectFile.selectedIndex==0 || !enableSettings.checked);
}

-->
</script>
<h2>Settings: </h2>
<form action="comport.php" method="post" >
<table>
  <tr><td >Protocols : </td><td >
<?php
print "<select id='COMPortFileSelect' name='href' onchange='enableCOMPortSettings()'>";
foreach ($filelist as $name => $val) {
	echo "<option value=\"", htmlspecialchars($val), "\""; 
	if ($confpath.$val==$href) echo " selected='selected'";
	echo ">", htmlspecialchars($name), "</option>\n";	
}
print "</select></td></tr>\n"; 

print "<tr><td ><input type='checkbox' $disableCOMFields id='ControlMonPower' onclick='enableCOMPortSettings()' name='monPower'";
if ($onTime!="00:00" || $offTime!="24:00"){
	 print "checked='checked' />";
	 $enableMonPower=$disableCOMFields;
}else{
	print "/>";
	$enableMonPower="disabled='disabled' ";
}
print "Control monitor power</td></tr >\n"; 
print "<tr><td>Turn monitor ON</td><td><input size='8' type='text' name='onTime' value=\"". htmlspecialchars($onTime) ."\" $enableMonPower/></td></tr>\n";
print "<tr><td>Turn monitor OFF</td><td><input size='8' type='text' name='offTime' value=\"". htmlspecialchars($offTime). "\" $enableMonPower/></td></tr>\n";

print "<tr><td ><input type='checkbox' $disableCOMFields id='ControlCOMPortSettings' onclick='enableCOMPortSettings()' name='comSettings'";
if (isset($comSettings)){
	print "checked='checked' />";
	$enableCOMSettings=$disableCOMFields;
}else{
	print "/>";
	$enableCOMSettings="disabled='disabled' ";
}
print "Modify COM port settings</td></tr >\n"; 

print "<tr><td >Baud rate : </td><td ><select name='baudRate' $enableCOMSettings>\n";
foreach ($BaudRatesSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
	if ($val==$baudRate) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td >Data bits : </td><td ><select name='byteSize' $enableCOMSettings>\n";
foreach ($byteSizeSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$byteSize) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td >Parity : </td><td ><select name='parity' $enableCOMSettings>\n";
foreach ($paritySet as $val) {
 	echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$parity) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
print "<tr><td >Stop bits : </td><td ><select name='stopBits' $enableCOMSettings>\n";
foreach ($stopBitsSet as $val) {
     echo "<option value=\"", htmlspecialchars($val), "\""; 
 	if ($val==$stopBits) echo " selected='selected'";
	echo ">", htmlspecialchars($val), "</option>\n";	
}
print "</select></td></tr>\n";
?>
</table>

<input type="submit" value="Apply" name="update"/>
</form>
<br/>
<h2>Upload Protocol File: </h2>
<br/>
<form action="comport.php" method="post" enctype="multipart/form-data">
<input size='40' type='file' name='new_file' /><br/>
<br/>
<input type="submit" value="Upload" name="upload"/>
</form>

<?php
} // not shutting down
include ("final.php");
?>