<?php

$title="Logs Settings"; 
include ("prolog.php");

$rollingfile=array("class"=>"org.apache.log4j.RollingFileAppender", "File"=>"File", "MaxFileSize" => "Max Size", "MaxBackupIndex" => "Nb File");
$file=array("class"=>"org.apache.log4j.FileAppender", "File"=>"File", "Append" => "Append", "BufferedIO" => "Buferered");
$console=array("class"=>"org.apache.log4j.ConsoleAppender", "Target"=>"Target");
$telnet=array("class"=>"org.apache.log4j.TelnetAppender", "Port"=>"Port");
$debug=array("class"=>"org.apache.log4j.OutputDebugStringAppender");
$appender=array("Rolling File"=>$rollingfile, "Telnet" =>$telnet, "File" =>$file, "Console" =>$console, "Debug" =>$debug);


// apply the changes 
$logappender=array();
$logger=array();
$log_priority="";
$log_appender=array();
if (isset($_POST['default_priority'])){
	$log_priority=$_POST['default_priority'];
	foreach($_POST as $name=>$value){
		// apender
		if (strncmp ($name,"appender_",9)==0){
			$name1=substr($name,9,strrpos($name,"_")-9);
			$name2=substr($name,strrpos($name,"_")+1);
			if ($name2=="active"){
				$log_appender[$name1]=1;
			}elseif ($name2!="Threshold" || $value!="default"){
				$logappender[$name1][$name2]=$value;
				$logappender[$name1]['name']=$name1;
			}
		}
		if (strncmp ($name,"logger_",7)==0){
			$name1=str_replace("_",".",substr($name,7,strrpos($name,"_")-7));
			$name2=substr($name,strrpos($name,"_")+1);
			if ($name2!="priority" || $value!="default")
				$logger[$name1][$name2]=$value;
		}
	}
	if (isset($_POST['new_appender_name']) && $_POST['new_appender_name'] && isset($_POST['new_appender_type'])){
		$name=$_POST['new_appender_name'];
		$logappender[$name]['name']=$name;
		$logappender[$name]['class']=$appender[$_POST['new_appender_type']]['class'];
	}
	if (isset($_POST['del_appender_name'])){
		$logappender[$_POST['del_appender_name']]=false;
		$log_appender[$_POST['del_appender_name']]=false;
	}

	// create the DOM
	$log=new DOMDocument;
	$root=$log->createElementNS("http://jakarta.apache.org/log4j/", "configuration");
	$root=$log->appendChild($root);
	$root->appendChild($log->createTextNode("\n"));
	// apenders
	foreach($logappender as $name => $val){
		if (!$val) continue;
		$app=$log->createElement("appender","\n");
		$app=$root->appendChild($app);
		$app->setAttribute("name",$val['name']);
		$app->setAttribute("class",$val['class']);
		foreach($val as $pname => $pval){
			if ($pname=='name' || $pname=='class') continue;
			if ($pname=='ConversionPattern'){
				$layout=$log->createElement("layout","\n");
				$layout->setAttribute("class","org.apache.log4j.PatternLayout");
				$param=$log->createElement("param");
				$param->setAttribute("name",$pname);
				$param->setAttribute("value",$pval);
				$layout->appendChild($param);
				$app->appendChild($layout);
			}else{
				$param=$log->createElement("param");
				$param->setAttribute("name",$pname);
				$param->setAttribute("value",$pval);
				$app->appendChild($param);
			}
			$app->appendChild($log->createTextNode("\n"));
		} 
		$root->appendChild($log->createTextNode("\n"));
	}
	// loggers
	foreach($logger as $name => $val){

		$l=$log->createElement("logger","\n");
		$l=$root->appendChild($l);
		$l->setAttribute("name",$name);
		foreach ($val as $aname=>$aval){
			if ($aname=='priority') {
				$priority=$log->createElement("priority");
				$priority->setAttribute("value",$aval);
				$l->appendChild($priority);
			}else{
				$app=$log->createElement("appender-ref");
				$app->setAttribute("ref",$aname);
				$l->appendChild($app);
			}
			$l->appendChild($log->createTextNode("\n"));
		}
		$root->appendChild($log->createTextNode("\n"));
	}

	// root
	$r=$log->createElement("root","\n");
	$priority=$log->createElement("priority");
	$priority->setAttribute("value",$log_priority);
	$r->appendChild($priority);
	$r->appendChild($log->createTextNode("\n"));
	foreach ($log_appender as $name=>$val){
		if (!$val)continue;
		$app=$log->createElement("appender-ref");
		$app->setAttribute("ref",$name);
		$r->appendChild($app);
		$r->appendChild($log->createTextNode("\n"));
	}
	$root->appendChild($r);
	$root->appendChild($log->createTextNode("\n"));
}	
?>

<?php
// get the config and the logs
$config_name="/srv/raperca/spxconfig.xml";

$config = new DOMDocument;
$concont=file_get_contents($config_name);
$config->loadXML($concont);

$logtag = $config->getElementsByTagName("log");
$defaultlog=true;
if (isset($logtag) && $logtag->length>0){
	// we have a log file config, open it
	$logfilename=$logtag->item(0)->getAttribute("configFile");
	$defaultlog=false;
}else
	$logfilename="logconfig.xml";

if (isset($_POST['default'])){
	$val=$_POST['default'];
	
	if($val==0 && $defaultlog) {
		$lognode=$config->createElement("log");
		$lognode->setAttribute("configFile",$logfilename);
		$config->documentElement->appendChild($lognode);
		$defaultlog=false;
	}elseif ($val==1 && !$defaultlog){
		$config->documentElement->removeChild($logtag->item(0));
		
		$defaultlog=true;
	}
}
$logfilename=substr($config_name,0,strrpos($config_name,"/"))."/".$logfilename;
if (isset($log)){
	file_put_contents($logfilename,$log->saveXML());
	file_put_contents($config_name,$config->saveXML(), true);
	reconfig_player();
}else{
	$log=new DOMDocument;
	$logcontent=file_get_contents($logfilename);
	
	if (isset($logcontent) && $logcontent && $logcontent!=""){
		$log->loadXML($logcontent);
		
	}

	$logappender=array();
	$appenders=$log->getElementsByTagName("appender");
	foreach ($appenders as $append){
		$app=array();
		$app['name']=$append->getAttribute("name");
		$app['class']=$append->getAttribute("class");
		$params=$append->getElementsByTagName("param");
		foreach($params as $param){
			$app[$param->getAttribute("name")]=$param->getAttribute("value");
		}
		$logappender[$app['name']]=$app;
	}
	//print_r( $logappender);
	
	$logger=array();
	$loggertags=$log->getElementsByTagName("logger");
	foreach($loggertags as $loggertag){
		$val=array();
		$appenders=$loggertag->getElementsByTagName("appender-ref");
		foreach ($appenders as $append){
			$val[$append->getAttribute("ref")]=1;
		}
		
		$tags=$loggertag->getElementsByTagName("priority");
		if ($tags->length>0)
			$val["priority"]=$tags->item(0)->getAttribute("value");
		if ($loggertag->hasAttribute("additivity"))
			$val["additivity"]=($loggertag->getAttribute("additivity")=="true");
		$logger[$loggertag->getAttribute("name")]=$val;
	}
	$roottag=$log->getElementsByTagName("root")->item(0);
	if (isset($roottag))
		$log_priority=$roottag->getElementsByTagName("priority")->item(0)->getAttribute("value");
	if (!isset($log_priority) )$log_priority="info";
	$log_appender=array();
	if (isset($roottag)){
		$appenders=$roottag->getElementsByTagName("appender-ref");
		foreach ($appenders as $append){
			$log_appender[$append->getAttribute("ref")]=1;
		}
	}
}


?>

<form action="logconfig.php" method="post">
<h2>Config: <input type="submit" value="Update" /></h2>

<table>
<?php
print ("<tr><td>Default configuration</td><td><input type='radio' name='default' value='1' ");
if ($defaultlog) print ("checked='checked' /></td></tr>");
else print ("/></td></tr>");
//print("<tr><td/><td>Hostname:</td><td><input size='30' type='text' name='hostname' value=\"". htmlspecialchars($conf->hostname). "\"/></td></tr>");
print ("<tr><td>Custom configuration</td><td><input type='radio' name='default' value='0' ");
if (!$defaultlog) print ("checked='checked' /></td></tr>");
else print ("/></td></tr>");
?>
</table>

<h2>Appender:</h2>

<?php
//print the appender

$active=array();
foreach($appender as $name => $conf){
	if (!$conf)continue;
	$first=true;
	foreach($logappender as $appname =>$base){
		$init=false;
		if ($base['class']==$conf['class']) $init=$base;
		//elseif ($first) $first=false;
		else continue;
		$active[$appname]=$base;
		print ("<h3> ". htmlspecialchars($init['name'])." </h3>\n");
		print "<table>\n";
		$appname="appender_".$init['name'];
			
		print("<tr><td>Subsribe to all loggers</td><td><input type='checkbox' name=\"". htmlspecialchars("${appname}_active"). "\" ");
		if (array_key_exists($init['name'], $log_appender)) print("checked='checked' ");
		print(" /></td></tr>\n");
		
		print("<tr><td>Type:</td><td>". htmlspecialchars($name). "<input type='hidden' name=\"". htmlspecialchars("${appname}_class"). "\" value=\"". htmlspecialchars($init['class'])."\" />\n");
		print("<input type='hidden' name=\"". htmlspecialchars("${appname}_ConversionPattern"). "\" value=\"". htmlspecialchars($init['ConversionPattern'])."\" /></td></tr>\n");
		
		$default=$trace=$debug=$info=$warn=$error=$fatal="";
		if ($init && array_key_exists("Threshold",$init)) ${$init['Threshold']}="selected='selected'";
		else $default="selected='selected'";
		print("<tr><td>Threshold:</td><td><select name=\"".htmlspecialchars($appname."_Threshold"). "\" >\n");
		print("<option $trace value='trace'>Trace</option><option $debug value='debug'>Debug</option><option $info value='info'>Info</option>\n");
		print("<option $warn value='warn'>Warning</option><option $error value='error'>Error</option><option $fatal value='fatal'>Fatal</option>\n");
		print("<option $default value='default'></option>\n");
		print("</select></td></tr>\n");
		print ("<tr><td>Format:</td><td><input size='60' type='text' name=\"".htmlspecialchars($appname."_ConversionPattern"). "\" ");
		if ($init && array_key_exists('ConversionPattern',$init)) print ("value=\"".htmlspecialchars($init['ConversionPattern'])."\" ");
		print("/></td></tr>\n");
		foreach($conf as $val=>$print){
			if ($val=="class") continue;
			print ("<tr><td>". htmlspecialchars($print). ": </td><td><input size='20' type='text' name=\"". htmlspecialchars($appname."_".$val)."\" ");
			if ($init && array_key_exists($val,$init)) print ("value=\"". htmlspecialchars($init[$val])."\" ");
			print("/></td></tr>\n");
		}
		print "</table>\n";
	}
}

?>

<?php
print("<br/>New appender-> name: <input size='20' type='text' name='new_appender_name' /> Type: "); 
print("<select name='new_appender_type'>\n");
print("<option value=''></option>\n");
foreach($appender as $name=>$val)
     print("<option value=\"". htmlspecialchars($name). "\">" . htmlspecialchars($name). "</option>\n");
print("</select>\n");

print("<br/><br/>Delete appender-> <select name='del_appender_name'>\n");
print("<option value=''></option>\n");
foreach($active as $name=>$val)
     print("<option value=\"". htmlspecialchars($name). "\">". htmlspecialchars($name). "</option>\n");
print("</select><br/>\n"); 

?>
<h2>Logger:</h2>
<table>
<?php
print ("<tr><td>Default: </td>");
$trace=$debug=$info=$warning=$error=$fatal="";
${$log_priority}="selected='selected'";
print("<td><select name='default_priority' >");
print("<option $trace value='trace'>Trace</option><option $debug value='debug'>Debug</option><option $info value='info'>Info</option>\n");
print("<option $warning value='warn'>Warning</option><option $error value='error'>Error</option><option $fatal value='fatal'>Fatal</option>\n");
print("</select>\n</td>\n</tr>\n");

$loggernames=array(
	"player"=>1,
	"resource"=>array("read"=>1,"write"=>1,"manage"=>1,"cache"=>1,"prepro"=>1,"fastcgi"=>1,"net"=>1,"media"=>1), 
	"svglib"=>array("media"=>array("mplayer"=>1,"timing"=>1,"packet"=>1,"ffmpeg"=>1, "flags"=>1,"sendpacket"=>1),"fonts"=>1, "paint"=>array("d3d9"=>1, "ds8"=>1, "oss"=>1, "kado"=>1), "profiling"=>1,"parse"=>1, "jscript"=>1, "multiscreen"=>1, "events"=>1, "rss"=>1), 
	"utils"=>array("thread"=>1,"xml"=>1), 
	"config"=>1, 
	"reporting"=>1, 
	"display" => array("directx"=>1,"opengl"=>1,"framebuffer"=>1,"file"=>1,"buffer"=>1,"media"=>1,"composrfsm"=>1,"input"=>1,"fonts"=>1,"render"=>1)
	);
print("<tr>");
print ("<td/>");
foreach($active as $name)
     print("<td>".htmlspecialchars($name['name'])."</td>");
print ("</tr>");


function print_log($loggernames, $active,$id,$level,$logger) {
	global $log_priority;
	foreach($loggernames as $name => $val){
		print("<tr><td>");
		for ($i=0; $i<$level; $i++) print ("--- ");
		print(htmlspecialchars($name). "</td>");
		$newid=$id.".$name";
		
		$logername="logger_".$newid;
		
		foreach($active as $cont){
			$name=$cont['name'];
			print("\n<td><input type='checkbox' name=\"". htmlspecialchars("${logername}_$name"). "\" ");
			if (array_key_exists($newid, $logger) && array_key_exists($name, $logger[$newid])) print("checked='checked' ");
			print(" /></td>");
			
		}
		
		$default=$trace=$debug=$info=$warn=$error=$fatal="";
		if (array_key_exists($newid, $logger) && array_key_exists('priority', $logger[$newid])) ${$logger[$newid]['priority']}="selected='selected'";
		else $default="selected='selected'";
		
		print("<td><select name=\"".htmlspecialchars($logername."_priority"). "\" >\n");
		print("<option $trace value='trace'>Trace</option><option $debug value='debug'>Debug</option><option $info value='info'>Info</option>\n");
		print("<option $warn value='warning'>Warning</option><option $error value='error'>Error</option><option $fatal value='fatal'>Fatal</option>\n");
		print("<option $default value='default'></option>\n");
		print("</select></td>\n");
		
		print("</tr>\n");
		if (is_array($val)){
			print_log($val, $active,$newid,$level+1,$logger);
		}
	}
}
$id="spx";
$level=0;
print_log($loggernames, $active,$id,$level,$logger);
?>
</table>
</form>
<h3>Logs</h3>
<a href="log/info.log">Info</a><br/>
<a href="log/warn.log">Warnings</a><br/>
<a href="log/">View Log folder</a><br/>
<?php
include "final.php";
?>
