<!DOCTYPE html PUBLIC "-//W3C//DTD XHTML 1.0 Transitional//EN" "http://www.w3.org/TR/xhtml1/DTD/xhtml1-transitional.dtd">
<html xmlns="http://www.w3.org/1999/xhtml">
<head>
<link rel="shortcut icon" href="ithemeSpinetix_favicon.ico" type="image/x-icon" />
<meta http-equiv="Content-Type" content="text/html; charset=UTF-8" />
<?php

# If we already have the helpers do not include it again
include_once "helpers.php";

$pagesInfo=array("Status"=>"welcome.php",
				"Snapshot"=>"preview.php",
				"Display Info"=>"screeninfo.php",
				"Storage"=>"content.php",
				"Logs" => "logs.php"
				);
$pagesSettings=array(
				"Display Settings"=>"displayconfig.php",
				"Network Settings"=>"ipconfig.php",
				"Media Sources"=>"playerconfig.php",
				"Security"=>"accessconfig.php",
				"Date/Time"=>"timesettings.php",
				"Serial Port"=>"comport.php",
				"Pull Mode"=>"uploader.php",
				"Firmware Update"=>"update.php",
				"Maintenance"=>"systemconfig.php");
$pagesAdvanced=array(
		"Player" => "advplayerconfig.php",
		"Logs Settings"	 =>"logconfig.php",
		"Files Management"	 =>"files.php",
		"Cache Settings"	 =>"advcacheconfig.php");
		
		
$advancedMode=false;
$query="";
$queryMulti="";
if (isset($_GET['advanced']) || isset($_POST['advanced']) || isset($pagesAdvanced[$title])){
	$advancedMode=true;
	$query="?advanced=1";	
	$queryMulti="&advanced=1";	
}

if (!isset($title)) $title="";
$cpuinfo=file_get_contents("/proc/cpuinfo");
if (preg_match("/Serial\W+0000(\w+)/",$cpuinfo,$match))
	$serial=$match[1];
else
	$serial="001d50xxxxxx";
	
$serialstring=$serial[0].$serial[1]."-".$serial[2].$serial[3]."-".$serial[4].$serial[5]."-".$serial[6].$serial[7]."-".$serial[8].$serial[9]."-".$serial[10].$serial[11];
echo "<title>HMP100 #".htmlspecialchars($serial).": $title</title>";
	
//check safe mode
$safemode=file_exists("/var/run/raperca.safe");

//check installation mode
$installationmode=file_exists("/var/run/reboot-delayed");
if (isset($_POST['instalation_mode'])){
	if ( $_POST['instalation_mode']=='Enable') $installationmode=true;
	if ( $_POST['instalation_mode']=='Disable') $installationmode=false;
}
//check firmware
$statusfn="/var/lib/updater/status";
if (!file_exists($statusfn)) $firmwareOK=true;
else $firmwareOK = ( trim(file_get_contents($statusfn))!="CORRUPTED" );
?>

<style type="text/css" media="all">@import "style.css";</style>
</head>
<body>
<div id="page">
<div id="wrapper">
<div id="header">
<h1>SpinetiX HMP100 Web Access</h1>
</div>
<div id="sidebar" >
<div id="sidebar-left">
<?php
if ($safemode) {
?>
<h3 class="red dbx-handle">Safe Mode</h3>
<div class="dbx-content">
	<ul class="menu">	
	<li class='leaf'><a href='safemode.php'>Information</a></li>
	</ul>
</div>	
<?php
}
?>

<h3 class="dbx-handle">Information</h3>
<div class="dbx-content">
	<ul class="menu">			
<?php
foreach ($pagesInfo as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\" class='active'>$pageName</a></li>";
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\">$pageName</a></li>";
	}
} 
?>
	</ul>
</div>
<h3 class="dbx-handle">Administration</h3>
<div class="dbx-content">
	<ul class="menu">			
<?php
foreach ($pagesSettings as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\" class='active'>$pageName</a></li>";
		$acitveUri=$pageURI;
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars("$pageURI$query"), "\">$pageName</a></li>";
	}
} 
?>
	</ul>
</div>
<?php
if ($advancedMode){
echo "<h3 class='dbx-handle'>Advanced</h3>";
echo "<div class='dbx-content'>";
echo "	<ul class='menu'>";			

foreach ($pagesAdvanced as $pageName => $pageURI){
	if ($pageURI==""){
		echo "<li class='leaf'> </li>";
	}else if ($title==$pageName){
	     echo "<li class='leaf'><a href=\"", htmlspecialchars($pageURI), "\" class='active'>$pageName</a></li>";
		$acitveUri=$pageURI;
	}else{
	     echo "<li class='leaf'><a href=\"", htmlspecialchars($pageURI), "\">$pageName</a></li>";
	}
} 
echo "	</ul>";
echo "</div>";
	}
	
echo "<h3 class='dbx-handle'>Serial Number</h3>";
echo "<div class='dbx-content'>";
echo "<ul class='menu'>";
echo "<li>$serialstring</li>";
echo "</ul>";
echo "</div>";
			
?>
</div>
</div>

<div id="left-col">

<?php

if (isset($tabs) && !isset($tabIdx)) {
	
	if (isset($_GET['tabs']))	
		$tabIdx=$_GET['tabs'];
	elseif (isset($_POST['tabs']))	
		$tabIdx=$_POST['tabs'];
	else
		$tabIdx=1;
}
if (isset($tabs) && isset($tabIdx)){
	
	echo "<div id='navtab$tabIdx' >";
	$idx=1;
	foreach ($tabs as $name){
		$className="tab".$idx;
		echo "<a class='$className' href=\"", htmlspecialchars("$acitveUri?tabs=$idx$queryMulti"), "\">$name</a>";
		$idx++;
	}
}else
	echo "<div id='nav' >";
?>
</div>
<div id="content">
<?php
if (!$firmwareOK) {
?>
<h2 class="red">Corrupted Firmware</h2>
<br/>
<p>
The current install of the HMP100 firmware is corrupted. 
This has probably been caused by a power cut during a firmware upgrade. 
In this case the system becomes corrupted, no further updates are possible and your system may be unstable.
</p>
<p>
To recover from this state do the following:
</p>
<ul>
	<li>Restart the HMP100 in diagnostics mode by clicking the "Restart Now" button below.</li>
	<li>Allow for up to 2 mins for the HMP100 to restart in diagnostics mode (a.k.a. recovery console).</li>
	<li>Open the recovery console on a web browser by typing the HMP's IP address in the URL bar (depending on your IP configuration the HMP100 might use an address in the range of 192.168.1.10 to 192.168.1.29)</li>
	<li>Click on the install factory image button, this will reinstall the factory firmware from scratch.</li>
	<li>Wait until the page shows that the install process is finished, if your browser times out you can repeatedly reload the page until it shows that the install is finished.</li>
	<li>Now your HMP is back with the factory firmware and with factory default configuration as if it was a new unit.</li>
	<li>Click the reboot button. Note that after reboot the IP address will be 192.168.1.10 (see <a href="http://www.spinetix.com/UserguideHMP/GetConnected">GetConnected</a>).</li>
</ul>
<p>
After this you need to reconfigure the network settings of your HMP and then you can restart the firmware upgrade, 
but do not cut down the power to the HMP during the firmware upgrade even if you see a big OK message on the web page. 
Let the upgrade process restart your HMP automatically. For more details see <a href="http://www.spinetix.com/firmware">http://www.spinetix.com/firmware</a>
</p>
<p>
In case of problems, please contact SpinetiX support (<a href="mailto:support@spinetix.com">support@spinetix.com</a>) 
</p>
<h2>Diagnostic Mode Restart</h2>
<br/>
<p>
	  Pressing "Restart Now" will restart the HMP100 in diagnostic (i.e., recovery) mode with the same network address, if one has been configured, 
     or with a free IP address in the range of 192.168.1.10 to 192.168.1.29 otherwise.<br/>
</p>
<form action="systemconfig.php" method="post" >
<input type="submit" value="Restart Now" name="rebootrecovery" /><br/>
</form>
<br/>  
<br/>
<?php
}
?>
<?php
if ( $installationmode ) {
	echo "<h2 class='red'>Installation Mode</h2>";
	echo "<p>The HMP100 is curently in instalation mode. Configuration changes will only be activated unpon restart.</p>";
	$pending=file_get_contents("/var/run/reboot-pending");
	if (!($pending===false)){
		echo "<p>Pending changes:</p>";
		$lines = explode("\n",$pending);
		echo "<ul>";
		foreach ($lines as $line) {
			if ($line!="") echo "<li>$line</li>";
		}
		echo "</ul>";
		echo "<form action='systemconfig.php' method='post' >";
		echo "<input type='submit' value='Restart Now' name='reboot' /><br/><br/>";
		echo "</form>";
	}
}
?>
