<?php
/*
 * Created on 8 Jun 2007 
 * By julien reichel <julien.reichel@spinetix.com>
 */

if (function_exists("to_readble_size") === FALSE) {
function to_readble_size($Bytes,$sufix="B")
{
  $Type=array("", "K", "M", "G", "T", "P", "E", "Z", "Y");
  $Index=0;
  while($Bytes>=1024)
  {
    $Bytes/=1024;
    $Index++;
  }
  $pre=0;
  if ($Bytes<100)
  	$pre++;
  if ($Bytes<10)
  	$pre++;
  $Bytes=round($Bytes,$pre);
  if ($sufix=="")
  	return($Bytes);
  else
  	return("".$Bytes." ".$Type[$Index].$sufix);
}
}

class sysinfo {
	var $sysinfo;
	
	var $info=array();
	var $scriptPath;
 	var $doc;
 	var $spxNS = 'http://www.spinetix.com/namespace/1.0/spx';
 	function sysinfo($reportName=0){
		if (isset($reportName) && $reportName)
			$this->readReport($reportName);
	}	
	function add($nodeName, $nodeValue, $root, $erase=0){
		if ($erase){
			$previous=$root->getElementsByTagName($nodeName);
			$dellist=array();
			foreach ($previous as $del){
				$dellist=$del;
			}
			foreach ($dellist as $del){
				$root->removeChild($del);
			}	
		}
		$element=$this->doc->createElement($nodeName, $nodeValue);
		$new=$root->appendChild($element);
		$root->appendChild($this->doc->createTextNode("\n"));
		return $new; 
		
	}
	function getNode($nodeName, $root){
		$nodes=$root->getElementsByTagName($nodeName);
		$ret=array();
		if (count($nodes)==1) $ret=$nodes->item(0);
		if (count($nodes)>1) {
			foreach($nodes as $node)
				$ret[]=$node;
		}
		return $ret;
	}
	function getNodeValue($nodeName, $root){
		$node=getNode($nodeName, $root);
		if ($node==NULL || is_array($node)) return "";
		else return $node->nodeValue;
	}
	function nodeToArray($root){
		$haschild=0;
		$info=array();
		$multi=array();
		foreach ($root->childNodes as $node){
			if ($node->nodeType==XML_ELEMENT_NODE){
				if (array_key_exists($node->nodeName, $info)){
					if (!array_key_exists($node->nodeName,$multi)){
						$old = $info[$node->nodeName];
						$info[$node->nodeName] = array();
						$info[$node->nodeName][]=$old;
						$multi[$node->nodeName] = 1;
					}
					$info[$node->nodeName][] = $this->nodeToArray($node);
				}else
					$info[$node->nodeName] = $this->nodeToArray($node);
				$haschild=1;
			}
		}
		if (!$haschild){
			$info=$root->nodeValue;
		}
		return $info;
	}
	function arrayToNode($root,$info){
		if (is_array($info)){
			foreach($info as $name => $val){
				if (is_array($val)){
					if (array_key_exists('0',$val)){
						foreach($val as $name2 => $val2){
							if (is_array($val2)){
								$newroot=$this->add($name,"\n",$root);
								$this->arrayToNode($newroot,$val2);
							}else $this->add($name,$val2,$root);
						}
					}else{ 
						$newroot=$this->add($name,"\n",$root);
						$this->arrayToNode($newroot,$val);
					}
				}else {
					$this->add($name,$val,$root);	
				}
			}
		}
	}
	function genReport($functions=0){
		if (PHP_OS=='WINNT')
			$this->sysinfo= new sysinfoWin32;
		elseif (PHP_OS=='Linux')
			$this->sysinfo= new sysinfoLinux;
		
		
		if (!isset($functions) || !$functions){
			// build for all
			$functions=array("display","network","sysinfo","status","usb","audio","disk");
		}
		
		if (!is_array($functions))
			$functions=array($functions);
		foreach ($functions as $function){
			switch ($function){
				case "display":
				$disinfo=$this->sysinfo->display();
				$this->info['display']['name']=$disinfo['name'];
				$this->info['display']['frequency']=$disinfo['freq'];
				$this->info['display']['displaywidth']=$disinfo['width'];
				$this->info['display']['displayheight']=$disinfo['height'];
				$this->info['display']['state']=$disinfo['state'];
				
				if (!array_key_exists('renderwidth', $this->info['display']) || !$this->info['display']['renderwidth']) 
					$this->info['display']['renderwidth']=$disinfo['width'];
				if (!array_key_exists('renderheight', $this->info['display']) || !$this->info['display']['renderheight']) 
					$this->info['display']['renderheight']=$disinfo['height'];
				
				break;
// *****************************				
				case "network":
				if (!array_key_exists('network', $this->info) || !array_key_exists('ipaddress', $this->info['network']) || !$this->info['network']['ipaddress'])
					$this->info['network']['ipaddress']=$this->sysinfo->ip_addr();
				if (!array_key_exists('network', $this->info) || !array_key_exists('hostname', $this->info['network']) || !$this->info['network']['hostname'])
					$this->info['network']['hostname']=$this->sysinfo->chostname();
				
				$netinfo=$this->sysinfo->network();
				$this->info['network']['interface']=array();
				foreach ($netinfo as $name => $device){
					$val=array();
					$val['name']=$name;
					$val['tx']=to_readble_size($device['tx_bytes']);
					$val['rx']=to_readble_size($device['rx_bytes']);
					$val['bandwidth']=to_readble_size($device['bandwidth'],'bps');
					$this->info['network']['interface'][]=$val;
				}
				break;
// *****************************				
				case "sysinfo":
				
				if (!array_key_exists('sysinfo', $this->info)){
					$cupinfo=$this->sysinfo->cpu_info();
					$this->info['sysinfo']['version']=$this->sysinfo->kernel();
					$this->info['sysinfo']['cpu']=$cupinfo['model'];
					$this->info['sysinfo']['serial']=$cupinfo['serial'];
					$this->info['sysinfo']['revision']=$cupinfo['revision'];
					if ($cupinfo['cpuspeed']!="N.A.")
						$this->info['sysinfo']['cpuspeed']=$cupinfo['cpuspeed']."MHz";
					
					$this->info['sysinfo']['cachesize']=$cupinfo['cache'];
					if (array_key_exists('busspeed', $cupinfo))
						$this->info['sysinfo']['busspeed']=$cupinfo['busspeed']."MHz";
				}
				if (!array_key_exists('phpversion', $this->info['sysinfo']) || !$this->info['sysinfo']['phpversion'])
					$this->info['sysinfo']['phpversion']=phpversion();
				if (!array_key_exists('platform', $this->info['sysinfo']) || !$this->info['sysinfo']['platform'])
					$this->info['sysinfo']['platform']=PHP_OS;
				if (PHP_OS=='Linux') {
					if (!array_key_exists('filesystem', $this->info['sysinfo'])){
						$filesysVersion=file_get_contents("/etc/spinetix-release");
						$res=preg_match("/version\s+(\S+)\s+build\s+(\S+)/", $filesysVersion, $versionInfo);
						if ($res==1){
							$this->info['sysinfo']['filesystem']['version']=$versionInfo[1];
							$this->info['sysinfo']['filesystem']['build']=$versionInfo[2];
						}
					}
					if (!array_key_exists('rpm', $this->info['sysinfo'])){
						$output=array();
						exec("rpm -q --queryformat '%{VERSION}-%{RELEASE}\n' raperca php cairo",$output);
						if (count($output)==3){
							$this->info['sysinfo']['rpm']['raperca']=$output[0];
							$this->info['sysinfo']['rpm']['php']=$output[1];
							$this->info['sysinfo']['rpm']['cairo']=$output[2];
						}
					}
					
				}
				break;				
// *****************************				
				case "status":
				
				$dateDiff = $this->sysinfo->uptime();
				$Days = floor($dateDiff/(60*60*24));
				$Hours = floor(($dateDiff-($Days*60*60*24))/(60*60));
				$Minutes = floor(($dateDiff-($Days*60*60*24)-($Hours*60*60))/60);
				
				$this->info['status']['uptime']=sprintf("%d days %dh%02d",$Days,$Hours,$Minutes);
				
				//memory
				$meminfo=$this->sysinfo->memory();
				$this->info['status']['memory']['used']=to_readble_size($meminfo['ram']['used']*1024);
				$this->info['status']['memory']['free']=to_readble_size($meminfo['ram']['free']*1024);
				$this->info['status']['memory']['total']=to_readble_size($meminfo['ram']['total']*1024);
				$this->info['status']['memory']['percent']=$meminfo['ram']['percent'];
				
				$this->info['status']['swap']['used']=to_readble_size($meminfo['swap']['used']*1024);
				$this->info['status']['swap']['free']=to_readble_size($meminfo['swap']['free']*1024);
				$this->info['status']['swap']['total']=to_readble_size($meminfo['swap']['total']*1024);
				$this->info['status']['swap']['percent']=$meminfo['swap']['percent'];
				
				if (array_key_exists('devswap',$meminfo) && count($meminfo['devswap'])>0) {
					$this->info['status']['swap']['devswap']=array();
					foreach($meminfo['devswap'] as $dev){
						$val=array();
						$val['name']=$dev['dev'];
						$val['used']=to_readble_size($dev['used']*1024);
						$val['free']=to_readble_size($dev['free']*1024);
						$val['total']=to_readble_size($dev['total']*1024);
						$val['percent']=$dev['percent'];
						$this->info['status']['swap']['devswap'][]=$val;
					}
				}
				break;
// *****************************				
				case "usb":
				$usblist=$this->sysinfo->usb();
				$this->info['usb']['device']=array();
				foreach ($usblist as $usb){
					$val=array();
					$val['name']=$usb;
					$this->info['usb']['device'][]=$val;
				}
				break;
// *****************************
				case "audio":
				break;
// *****************************
				case "disk":
				
				if (array_key_exists('disk', $this->info) && array_key_exists('serverPath', $this->info['disk']) && $this->info['disk']['serverPath']){
					$freespace           = disk_free_space($this->info['disk']['serverPath']);
					$total_space         = disk_total_space($this->info['disk']['serverPath']);
					$percentage_free	 = $total_space ? 100 - round($freespace / $total_space, 2) * 100 : 0;
					$this->info['disk']['server']['used']=to_readble_size($total_space-$freespace);
					$this->info['disk']['server']['free']=to_readble_size($freespace);
					$this->info['disk']['server']['percent']=$percentage_free;
					$this->info['disk']['server']['total']=to_readble_size($total_space);
				}else{
					$this->info['disk']['server']['percent']=0;
				}
				if (array_key_exists('disk', $this->info) && array_key_exists('usbPath', $this->info['disk']) && $this->info['disk']['usbPath']){
					$freespace           = disk_free_space($this->info['disk']['usbPath']);
					$total_space         = disk_total_space($this->info['disk']['usbPath']);
					if ($total_space>0){
						$percentage_free	 = $total_space ? 100 - round($freespace / $total_space, 2) * 100 : 0;
						$this->info['disk']['usb']['used']=to_readble_size($total_space-$freespace);
						$this->info['disk']['usb']['free']=to_readble_size($freespace);
						$this->info['disk']['usb']['percent']=$percentage_free;
						$this->info['disk']['usb']['total']=to_readble_size($total_space);
					}
				}
				/*
				$home=array('mount' => '/home', 'used' => 0, 'free' => 0, 'size' => 0);
				$this->fileinfo=$this->sysinfo->filesystems();
				$this->info['disk']['mount']=array();
				foreach ($this->fileinfo as $disk){
					if (!(strpos($disk['mount'],'/home')===false)){
						$home['used']+=$disk['used'];
						$home['free']+=$disk['free'];
						$home['size']+=$disk['size'];
						$home['disk']=$disk['disk'];
						$home['fstype']=$disk['fstype'];
					}elseif($disk['disk']!="Network Drive"){
						$val=array();
						$val['name']=$disk['mount'];
						$val['free']=to_readble_size($disk['free']*1024);
						$val['used']=to_readble_size($disk['used']*1024);
						$val['total']=to_readble_size($disk['size']*1024);
						$val['percent']=$disk['percent'];
						$val['disk']=$disk['disk'];
						$val['type']=$disk['fstype'];
						$this->info['disk']['mount'][]=$val;
					}
				}
				if ($home['size']>0){
					$home['percent']=round(100*$home['used']/$home['size']);
					$val=array();
					$val['name']=$home['mount'];
					$val['free']=to_readble_size($home['free']*1024);
					$val['used']=to_readble_size($home['used']*1024);
					$val['total']=to_readble_size($home['size']*1024);
					$val['percent']=$home['percent'];
					$val['disk']=$home['disk'];
					$val['type']=$home['fstype'];
					$this->info['disk']['mount'][]=$val;
				}
				*/
				break;
			}
		}
		if (isset($this->scriptPath)) $this->info['player']['script']=$this->scriptPath;
		
	}
	function saveReport($docname){
		$this->doc = new DOMDocument;
		$element = $this->doc->createElementNS($this->spxNS, 'info');
		$this->doc->appendChild($element);
		$this->arrayToNode($element,$this->info);
		//print_r($this->info);
		//echo $this->doc->saveXML();
		if (isset($this->scriptPath)){
			$pi=new DOMProcessingInstruction("spx", "phpscript='".$this->scriptPath."' max-age='60'");
			$this->doc->insertBefore($pi,$this->doc->documentElement);
		}
		file_put_contents($docname,$this->doc->saveXML());
	}
	function readReport($docname){
		$this->doc = new DOMDocument;
		$cont=file_get_contents($docname);
		if (isset($cont) && $cont && $cont!=""){
			$this->doc->loadXML($cont);
			$this->info=$this->nodeToArray($this->doc->documentElement);
			if (array_key_exists('player', $this->info) && array_key_exists('script', $this->info['player'])) 
				$this->scriptPath=$this->info['player']['script'];
		}else{
			$this->info['config']['configPath']='../spxconfig.xml';
		}
	}
}
	 

class sysinfoWin32 {
  // $wmi holds the COM object that we pull all the WMI data from
  var $wmi; 

  // $wmidevices holds all devices, which are in the system
  var $wmidevices;

  // this constructor initialis the $wmi object
  function sysinfoWin32 ()
  {
    
    // initialize the wmi object
    $objLocator = new COM("WbemScripting.SWbemLocator");
    $this->wmi = $objLocator->ConnectServer();
    
  } 

  // private function for getting a list of values in the specified context, optionally filter this list, based on the list from second parameter
  function _GetWMI($strClass, $strValue = array() ) {
    $objWEBM = $this->wmi->Get($strClass);

    if( PHP_VERSION < 5 ) {
      $objProp = $objWEBM->Properties_;
      $arrProp = $objProp->Next($objProp->Count);
      $objWEBMCol = $objWEBM->Instances_();
      $arrWEBMCol = $objWEBMCol->Next($objWEBMCol->Count);
    } else {
      $arrProp = $objWEBM->Properties_;
      $arrWEBMCol = $objWEBM->Instances_();
    }

    foreach($arrWEBMCol as $objItem)
    {
        @reset($arrProp);
        $arrInstance = array();
        foreach($arrProp as $propItem)
        {
            eval("\$value = \$objItem->" .$propItem->Name .";");
            if( empty( $strValue ) ) {
              $arrInstance[$propItem->Name] = trim($value);
            } else {
              if( in_array( $propItem->Name, $strValue ) ) {
                $arrInstance[$propItem->Name] = trim($value);
              }
            }
        }
        $arrData[] = $arrInstance;
    }
    return $arrData;
  }

  // private function for getting different device types from the system
  function _devicelist ( $strType ) {
    if( empty( $this->wmidevices ) ) {
      $this->wmidevices = $this->_GetWMI( "Win32_PnPEntity", array( "Name", "PNPDeviceID" ) );
    }

    $list = array();
    foreach ( $this->wmidevices as $device ) {
      if ( substr( $device["PNPDeviceID"], 0, strpos( $device["PNPDeviceID"], "\\" ) + 1 ) == ( $strType . "\\" ) ) {
        $list[] = $device["Name"];
      } 
    }

    return $list;
  }
  
  // get our apache SERVER_NAME or vhost
  function vhostname () {
    if (! ($result = getenv('SERVER_NAME'))) {
      $result = 'N.A.';
    } 
    return $result;
  } 

  // get the IP address of our vhost name
  function vip_addr () {
    return gethostbyname($this->vhostname());
  }

  // get our canonical hostname
  function chostname ()
  {
    $buffer = $this->_GetWMI( "Win32_ComputerSystem", array( "Name" ) );
    $result = $buffer[0]["Name"];
    return gethostbyaddr(gethostbyname($result));
  }

  // get the IP address of our canonical hostname
  function ip_addr ()
  {
    $buffer = $this->_GetWMI( "Win32_ComputerSystem", array( "Name" ) );
    $result = $buffer[0]["Name"];
    return gethostbyname($result);
  }

  function kernel ()
  {
    $buffer = $this->_GetWMI( "Win32_OperatingSystem", array( "Version", "ServicePackMajorVersion" ) );
    $result = $buffer[0]["Version"];
    if( $buffer[0]["ServicePackMajorVersion"] > 0 ) {
      $result .= " SP" . $buffer[0]["ServicePackMajorVersion"];
    }
    return $result;
  } 

  // get the time the system is running
  function uptime ()
  {
    $result = 0;
    $buffer = $this->_GetWMI( "Win32_OperatingSystem", array( "LastBootUpTime", "LocalDateTime" ) );

    $byear = intval(substr($buffer[0]["LastBootUpTime"], 0, 4));
    $bmonth = intval(substr($buffer[0]["LastBootUpTime"], 4, 2));
    $bday = intval(substr($buffer[0]["LastBootUpTime"], 6, 2));
    $bhour = intval(substr($buffer[0]["LastBootUpTime"], 8, 2));
    $bminute = intval(substr($buffer[0]["LastBootUpTime"], 10, 2));
    $bseconds = intval(substr($buffer[0]["LastBootUpTime"], 12, 2));

    $lyear = intval(substr($buffer[0]["LocalDateTime"], 0, 4));
    $lmonth = intval(substr($buffer[0]["LocalDateTime"], 4, 2));
    $lday = intval(substr($buffer[0]["LocalDateTime"], 6, 2));
    $lhour = intval(substr($buffer[0]["LocalDateTime"], 8, 2));
    $lminute = intval(substr($buffer[0]["LocalDateTime"], 10, 2));
    $lseconds = intval(substr($buffer[0]["LocalDateTime"], 12, 2));

    $boottime = mktime($bhour, $bminute, $bseconds, $bmonth, $bday, $byear);
    $localtime = mktime($lhour, $lminute, $lseconds, $lmonth, $lday, $lyear);

    $result = $localtime - $boottime;

    return $result;
  } 

  // count the users, which are logged in
  function users ()
  {
    if( stristr( $this->kernel(), "2000 P" ) ) return "N.A."; 
    $buffer = $this->_GetWMI( "Win32_PerfRawData_TermService_TerminalServices", array( "TotalSessions" ) );
    return $buffer[0]["TotalSessions"];
  } 

  // get the load of the processors
  function loadavg ()
  {
    $buffer = $this->_GetWMI( "Win32_Processor", array( "LoadPercentage" ) );
    $cpuload = array();
    for( $i = 0; $i < count( $buffer ); $i++ ) {
      $cpuload['avg'][] = $buffer[$i]["LoadPercentage"]/100;
    }
    
    return $cpuload;
  } 

  // get some informations about the cpu's
  function cpu_info ()
  {
    $buffer = $this->_GetWMI( "Win32_Processor", array( "Name", "L2CacheSize", "CurrentClockSpeed", "ExtClock" ) );
    $results["cpus"] = 0;
    foreach ($buffer as $cpu) {
      $results["cpus"]++;
      $results["model"] = $cpu["Name"];
      $results["cache"] = $cpu["L2CacheSize"]." KB";
      $results["cpuspeed"] = $cpu["CurrentClockSpeed"];
      $results["busspeed"] = $cpu["ExtClock"];
      $results["serial"] = "N.A.";
	  $results['revision'] = "";
    } 
    return $results;
  } 

  function display ()
  {
  	$statearray = array( "Other", "Unknown", "Running", "Warning", "In Test", "N/A", "Power Off", 
						"Off Line", "Off Duty", "Degraded", "Not Installed", "Install Error", "Power Save", "Power Save", "Standby", "Power Cycle", "Power Save");
    $buffer = $this->_GetWMI( "CIM_VideoController", array( "VideoProcessor", "Availability", "CurrentHorizontalResolution", "CurrentVerticalResolution", "CurrentRefreshRate" ) );
    foreach ($buffer as $interface) {
	    $results["state"] = $statearray[$interface["Availability"]-1];
	    //$results["state"] = $interface["Status"];
	    $results["width"] = $interface["CurrentHorizontalResolution"];
	    $results["height"] = $interface["CurrentVerticalResolution"];
	    $results["freq"] = $interface["CurrentRefreshRate"];
	    $results["name"] = $interface["VideoProcessor"];
	    $results["aspect"] = "N/A";
    }
    return $results;
  }
  
  // get the usb devices from the system
  function usb ()
  {
    $usb = $this->_devicelist( "USB" );
    return $usb;
  } 

	// get the netowrk devices and rx/tx bytes
	function network () {
		$results = array();
		$buffer = $this->_GetWMI( "Win32_PerfRawData_Tcpip_NetworkInterface" );
		foreach( $buffer as $device ) {
			$dev_name = $device["Name"];
			// http://msdn.microsoft.com/library/default.asp?url=/library/en-us/wmisdk/wmi/win32_perfrawdata_tcpip_networkinterface.asp
			// there is a possible bug in the wmi interfaceabout uint32 and uint64: http://www.ureader.com/message/1244948.aspx, so that
			// magative numbers would occour, try to calculate the nagative value from total - positive number
			
			if( $device["BytesSentPersec"] < 0) {
				$results[$dev_name]['tx_bytes'] = -$device["BytesSentPersec"];
			} else {
				$results[$dev_name]['tx_bytes'] = $device["BytesSentPersec"];
			}
			if( $device["BytesReceivedPersec"] < 0 ) {
				$results[$dev_name]['rx_bytes'] = -$device["BytesReceivedPersec"];
			} else {
				$results[$dev_name]['rx_bytes'] = $device["BytesReceivedPersec"];
			}
			
			$results[$dev_name]['rx_packets'] = $device["PacketsReceivedPersec"];
			$results[$dev_name]['tx_packets'] = $device["PacketsSentPersec"];
			
			$results[$dev_name]['rx_errs'] = $device["PacketsReceivedErrors"];
			$results[$dev_name]['rx_drop'] = $device["PacketsReceivedDiscarded"];
			
			$results[$dev_name]['errs'] = $device["PacketsReceivedErrors"];
			$results[$dev_name]['drop'] = $device["PacketsReceivedDiscarded"];
			
			$results[$dev_name]['bandwidth'] = $device["CurrentBandwidth"];
		}
		
		return $results;
	} 

  function memory ()
  {
    $buffer = $this->_GetWMI( "Win32_LogicalMemoryConfiguration", array( "TotalPhysicalMemory" ) );
    $results['ram']['total'] = $buffer[0]["TotalPhysicalMemory"];

    $buffer = $this->_GetWMI( "Win32_PerfRawData_PerfOS_Memory", array( "AvailableKBytes" ) );
    $results['ram']['free'] = $buffer[0]["AvailableKBytes"];

    $results['ram']['used'] = $results['ram']['total'] - $results['ram']['free'];
    $results['ram']['percent'] = ceil( ( $results['ram']['used'] * 100 ) / $results['ram']['total'] );
    $results['swap']['total'] = 0;
    $results['swap']['used'] = 0;
    $results['swap']['free'] = 0;

    $buffer = $this->_GetWMI( "Win32_PageFileUsage" ); // no need to filter, using nearly everything from output
    $k = 0;
    foreach ($buffer as $swapdevice) {
      $results['devswap'][$k]['dev'] = $swapdevice["Name"];
      $results['devswap'][$k]['total'] = $swapdevice["AllocatedBaseSize"] * 1024;
      $results['devswap'][$k]['used'] = $swapdevice["CurrentUsage"] * 1024;
      $results['devswap'][$k]['free'] = ( $swapdevice["AllocatedBaseSize"] - $swapdevice["CurrentUsage"] ) * 1024;
      $results['devswap'][$k]['percent'] = ceil( $swapdevice["CurrentUsage"] / $swapdevice["AllocatedBaseSize"] );

      $results['swap']['total'] += $results['devswap'][$k]['total'];
      $results['swap']['used'] += $results['devswap'][$k]['used'];
      $results['swap']['free'] += $results['devswap'][$k]['free'];
      $k += 1;
    } 
    $results['swap']['percent'] = ceil( $results['swap']['used'] / $results['swap']['total'] * 100 );
    return $results;
  } 

  // get the filesystem informations
  function filesystems ()
  {
     $typearray = array("Unknown", "No Root Directory", "Removeable Disk",
        "Local Disk", "Network Drive", "Compact Disc", "RAM Disk");
     $floppyarray = array("Unknown", "5 1/4 in.", "3 1/2 in.", "3 1/2 in.",
        "3 1/2 in.", "3 1/2 in.", "5 1/4 in.", "5 1/4 in.", "5 1/4 in.",
        "5 1/4 in.", "5 1/4 in.", "Other", "HD", "3 1/2 in.", "3 1/2 in.",
        "5 1/4 in.", "5 1/4 in.", "3 1/2 in.", "3 1/2 in.", "5 1/4 in.",
        "3 1/2 in.", "3 1/2 in.", "8 in.");

    $buffer = $this->_GetWMI( "Win32_LogicalDisk" , array( "Name", "Size", "FreeSpace", "FileSystem", "DriveType", "MediaType" ) );

    $k = 0;
    foreach ( $buffer as $filesystem ) {
      /*if ( hide_mount( $filesystem["Name"] ) ) {
        continue;
      }*/
      $results[$k]['mount'] = $filesystem["Name"];
      $results[$k]['size'] = $filesystem["Size"] / 1024;
      $results[$k]['used'] = ( $filesystem["Size"] - $filesystem["FreeSpace"] ) / 1024;
      $results[$k]['free'] = $filesystem["FreeSpace"] / 1024;
      @$results[$k]['percent'] = ceil( $results[$k]['used'] / $results[$k]['size'] * 100 );  // silence this line, nobody is having a floppy in the drive everytime
      $results[$k]['fstype'] = $filesystem["FileSystem"];
      $results[$k]['disk'] = $typearray[$filesystem["DriveType"]];
      if ( $filesystem["MediaType"] != ""  && $filesystem["DriveType"] == 2 ) $results[$k]['disk'] .= " (" . $floppyarray[$filesystem["MediaType"]] . ")";
      $k += 1;
    } 
    return $results;
  } 

  function distro ()
  {
    $buffer = $this->_GetWMI( "Win32_OperatingSystem", array( "Caption" ) );
    return $buffer[0]["Caption"];
  } 

  function distroicon ()
  {
    return 'xp.gif';
  } 
} 


class sysinfoLinux {
	var $inifile = "distros.ini";
	var $icon = "unknown.png";
	var $distro = "unknown";
	var $parser;
	
	// get the distro name and icon when create the sysinfo object
	function sysinfoLinux() {
  		$this->parser = new Parser();
		$this->parser->df_param = 'P';
		
		$list = @parse_ini_file(APP_ROOT . "/" . $this->inifile, true);
		if (!$list) {
			return;
		}
		
		$distro_info = execute_program('lsb_release','-a 2> /dev/null', false);  // We have the '2> /dev/null' because Ubuntu gives an error on this command which causes the distro to be unknown
		if ( $distro_info != 'ERROR') {
			$distro_tmp = split("\n",$distro_info);
			foreach( $distro_tmp as $info ) {
				$info_tmp = split(':', $info, 2);
				$distro[ $info_tmp[0] ] = trim($info_tmp[1]);
			}
			if( !isset( $list[$distro['Distributor ID']] ) ){
				return;
			}
			$this->icon = isset($list[$distro['Distributor ID']]["Image"]) ? $list[$distro['Distributor ID']]["Image"] : $this->icon;
			$this->distro = $distro['Description'];
		} else {  // Fall back in case 'lsb_release' does not exist ;)
			foreach ($list as $section => $distribution) {
				if (!isset($distribution["Files"])) {
					continue;
				} else {
					foreach (explode(";", $distribution["Files"]) as $filename) {
						if (file_exists($filename)) {
							$buf = rfts( $filename );
							$this->icon = isset($distribution["Image"]) ? $distribution["Image"] : $this->icon;
							$this->distro = isset($distribution["Name"]) ? $distribution["Name"] . " " . trim($buf) : trim($buf);
							break 2;
						}
					}
				}
			}
		}
	}
  
  // get our apache SERVER_NAME or vhost
  function vhostname () {
    if (! ($result = getenv('SERVER_NAME'))) {
      $result = 'N.A.';
    } 
    return $result;
  } 
  // get the IP address of our vhost name
  function vip_addr () {
    return gethostbyname($this->vhostname());
  }
  // get our canonical hostname
  function chostname () {
    $result = rfts( '/proc/sys/kernel/hostname', 1 );
    if ( $result == "ERROR" ) {
      $result = "N.A.";
    } else {
      $result = gethostbyaddr( gethostbyname( trim( $result ) ) );
    } 
    return $result;
  } 
  // get the IP address of our canonical hostname
  function ip_addr () {
    if (!($result = getenv('SERVER_ADDR'))) {
      $result = gethostbyname($this->chostname());
    } 
    return $result;
  } 

  function kernel () {
    $buf = rfts( '/proc/version', 1 );
    if ( $buf == "ERROR" ) {
      $result = "N.A.";
    } else {
      if (preg_match('/version (.*?) /', $buf, $ar_buf)) {
        $result = $ar_buf[1];

        if (preg_match('/SMP/', $buf)) {
          $result .= ' (SMP)';
        } 
      } 
    } 
    return $result;
  } 
  
  function uptime () {
    $buf = rfts( '/proc/uptime', 1 );
    $ar_buf = split( ' ', $buf );
    $result = trim( $ar_buf[0] );

    return $result;
  } 

	function users () {
		$strResult = 0;
  		$strBuf = execute_program('who', '-q');
		if( $strBuf != "ERROR" ) {
			$arrWho = split( '=', $strBuf );
    			$strResult = $arrWho[1];
		}
		return $strResult;
	}

  function loadavg () {
    $buf = rfts( '/proc/loadavg' );
    if( $buf == "ERROR" ) {
      $results['avg'] = array('N.A.', 'N.A.', 'N.A.');
    } else {
      $results['avg'] = preg_split("/\s/", $buf, 4);
      unset($results['avg'][3]);	// don't need the extra values, only first three
    } 
    
    return $results;
  } 

	function cpu_info () {
		$bufr = rfts( '/proc/cpuinfo' );
		$results = array("cpus" => 0);
		
		if ( $bufr != "ERROR" ) {
			$bufe = explode("\n", $bufr);
			
			$results = array('cpus' => 0, 'bogomips' => 0);
			$ar_buf = array();
			
			foreach( $bufe as $buf ) {
				$arrBuff = preg_split('/\s+:\s+/', trim($buf));
				if( count( $arrBuff ) == 2 ) {
					$key = $arrBuff[0];
					$value = $arrBuff[1];
					// All of the tags here are highly architecture dependant.
					// the only way I could reconstruct them for machines I don't
					// have is to browse the kernel source.  So if your arch isn't
					// supported, tell me you want it written in.
					switch ($key) {
						case 'Hardware':
						case 'model name':
							$results['model'] = $value;
							break;
						case 'cpu MHz':
							$results['cpuspeed'] = sprintf('%.2f', $value);
							break;
						case 'cache size':
							$results['cache'] = $value;
							break;
						case 'I size':
							$results['cache'] = ($value/1024)." KB";
							break;
						case 'bogomips':
							$results['bogomips'] += $value;
							break;
						case 'processor':
							$results['cpus'] += 1;
							break;
						case 'Revision':
							$results['revision'] = $value;
							break;
						case 'Serial':
							$results['serial'] = substr($value,4);
							break;
		 			}
				}
			}
		}		
		$keys = array_keys($results);
		$keys2be = array('model', 'cpuspeed', 'cache', 'bogomips', 'cpus');
		
		while ($ar_buf = each($keys2be)) {
			if (! in_array($ar_buf[1], $keys)) {
				$results[$ar_buf[1]] = 'N.A.';
			} 
		}
		
		$buf = rfts( '/proc/acpi/thermal_zone/THRM/temperature', 1, 4096, false );
		if ( $buf != "ERROR" ) {
			$results['temp'] = substr( $buf, 25, 2 );
		}
		
		return $results;
	}
  function display ()
  {
  	$vidmod=file_get_contents("/sys/class/graphics/fb0/device/vid_mode");
  	if (preg_match("/(\d+)x(\d+)@(\d+)[pi]-(\S+)/",$vidmod,$match)){
  		$results["width"] = $match[1];
	    $results["height"] = $match[2];
	    $results["freq"] = $match[3];
	    $results["aspect"] = $match[4];
  	}else{
	  	$results["state"] = "N/A";
	    $results["width"] = 0;
	    $results["height"] = 0;
	    $results["freq"] = 0;
	    $results["aspect"] = "N/A";
	    $results["name"] = "unknown";
  	}
    return $results;
  }

 function usb () {
	$results = array();
	$devnum = -1;
	
	$bufr = rfts( '/proc/bus/usb/devices', 0, 4096, false );
	if ( $bufr != "ERROR" ) {
	    $bufe = explode("\n", $bufr);
		foreach( $bufe as $buf ) {
			if (preg_match('/^T/', $buf)) {
		    	$devnum += 1;
			    $results[$devnum] = "";
			} elseif (preg_match('/^S:/', $buf)) {
		    	list($key, $value) = split(': ', $buf, 2);
		    	list($key, $value2) = split('=', $value, 2);
			    if (trim($key) != "SerialNumber" && trim($key) != "Manufacturer") {
		    		$results[$devnum] .= " " . trim($value2);
		        	$devstring = 0;
				}
		    } 
		}
	}    
    return $results;
} 


function network () {
    $results = array();

    $bufr = rfts( '/proc/net/dev' );
    if ( $bufr != "ERROR" ) {
      $bufe = explode("\n", $bufr);
      foreach( $bufe as $buf ) {
        if (preg_match('/:/', $buf)) {
          list($dev_name, $stats_list) = preg_split('/:/', $buf, 2);
          $stats = preg_split('/\s+/', trim($stats_list));
          $results[$dev_name] = array();

          $results[$dev_name]['rx_bytes'] = $stats[0];
          $results[$dev_name]['rx_packets'] = $stats[1];
          $results[$dev_name]['rx_errs'] = $stats[2];
          $results[$dev_name]['rx_drop'] = $stats[3];

          $results[$dev_name]['tx_bytes'] = $stats[8];
          $results[$dev_name]['tx_packets'] = $stats[9];
          $results[$dev_name]['tx_errs'] = $stats[10];
          $results[$dev_name]['tx_drop'] = $stats[11];
          
          $results[$dev_name]['bandwidth'] = 0;

          $results[$dev_name]['errs'] = $stats[2] + $stats[10];
          $results[$dev_name]['drop'] = $stats[3] + $stats[11];
        } 
      }
    }
    return $results;
} 

  function memory () {
    $results['ram'] = array('total' => 0, 'free' => 0, 'used' => 0, 'percent' => 0);
    $results['swap'] = array('total' => 0, 'free' => 0, 'used' => 0, 'percent' => 0);
    $results['devswap'] = array();

    $bufr = rfts( '/proc/meminfo' );
    if ( $bufr != "ERROR" ) {
      $bufe = explode("\n", $bufr);
      foreach( $bufe as $buf ) {
        if (preg_match('/^MemTotal:\s+(.*)\s*kB/i', $buf, $ar_buf)) {
          $results['ram']['total'] = $ar_buf[1];
        } else if (preg_match('/^MemFree:\s+(.*)\s*kB/i', $buf, $ar_buf)) {
          $results['ram']['free'] = $ar_buf[1];
        } else if (preg_match('/^Cached:\s+(.*)\s*kB/i', $buf, $ar_buf)) {
          $results['ram']['cached'] = $ar_buf[1];
        } else if (preg_match('/^Buffers:\s+(.*)\s*kB/i', $buf, $ar_buf)) {
          $results['ram']['buffers'] = $ar_buf[1];
        } 
      } 

      $results['ram']['used'] = $results['ram']['total'] - $results['ram']['free']- $results['ram']['cached']- $results['ram']['buffers'];
      $results['ram']['percent'] = round(($results['ram']['used'] * 100) / $results['ram']['total']);
      
      // values for splitting memory usage
      if (isset($results['ram']['cached']) && isset($results['ram']['buffers'])) {
        $results['ram']['app'] = $results['ram']['used'] - $results['ram']['cached'] - $results['ram']['buffers'];
	$results['ram']['app_percent'] = round(($results['ram']['app'] * 100) / $results['ram']['total']);
	$results['ram']['buffers_percent'] = round(($results['ram']['buffers'] * 100) / $results['ram']['total']);
	$results['ram']['cached_percent'] = round(($results['ram']['cached'] * 100) / $results['ram']['total']);
      }
    }
    return $results;
  } 
  
  function filesystems () {
    return $this->parser->parse_filesystems();
  } 

  function distro () {
   return $this->distro;
  }

  function distroicon () {   
   return $this->icon;
  }

} 

class Parser {
	var $debug	= false;
	var $df_param	= "";
	
	function parse_lspci() {
		
		$arrResults = array();
		
		if ( ( $strBuff = execute_program( "lspci", "", $this->debug ) ) != "ERROR" ) {
			$arrLines = split( "\n", $strBuff );
			foreach( $arrLines as $strLine ) {
				list( $strAddr, $strName) = explode( ' ', trim( $strLine ), 2 );
				$strName = preg_replace( '/\(.*\)/', '', $strName);
				$arrResults[] = $strName;
			}
		}
		if( empty( $arrResults ) ) {
			return false;
		} else {
			asort( $arrResults );
			return $arrResults;
		}
	}
	
	function parse_pciconf() {
		
		$arrResults = array();
		$intS = 0;
		
		if( ( $strBuff = execute_program( "pciconf", "-lv", $this->debug ) ) != "ERROR" ) {
			$arrLines = explode( "\n", $strBuff );
			foreach( $arrLines as $strLine ) {
				if( preg_match( "/(.*) = '(.*)'/", $strLine, $arrParts ) ) {
					if( trim( $arrParts[1] ) == "vendor" ) {
						$arrResults[$intS] = trim( $arrParts[2] );
					} elseif( trim( $arrParts[1]) == "device" ) {
						$arrResults[$intS] .= " - " . trim( $arrParts[2] );
						$intS++;
					}
				}
			}
		}
		if( empty( $arrResults ) ) {
			return false;
		} else {
			asort( $arrResults );
			return $arrResults;
		}
	}
	
	function parse_filesystems() {
		
		global $show_bind, $show_inodes;
		
		$results = array();
		$j = 0;
		
		$df = execute_program('df', '-k' . $this->df_param );
		$df = preg_split("/\n/", $df, -1, PREG_SPLIT_NO_EMPTY);
		sort($df);
		if( $show_inodes ) {
			$df2 = execute_program('df', '-i' . $this->df_param );
			$df2 = preg_split("/\n/", $df2, -1, PREG_SPLIT_NO_EMPTY);
			sort( $df2 );
		}
		$mount = execute_program('mount');
		$mount = preg_split("/\n/", $mount, -1, PREG_SPLIT_NO_EMPTY);
		sort($mount);
		
		foreach( $df as $df_line) {
			$df_buf1  = preg_split("/(\%\s)/", $df_line, 2);
			if( count($df_buf1) != 2) {
				continue;
			}
			preg_match("/(.*)(\s+)(([0-9]+)(\s+)([0-9]+)(\s+)([0-9]+)(\s+)([0-9]+)$)/", $df_buf1[0], $df_buf2);
			$df_buf = array($df_buf2[1], $df_buf2[4], $df_buf2[6], $df_buf2[8], $df_buf2[10], $df_buf1[1]);
			if( $show_inodes ) {
				preg_match_all("/([0-9]+)%/", $df2[$j + 1], $inode_buf, PREG_SET_ORDER);
			}
			if( count($df_buf) == 6 ) {
				$df_buf[5] = trim( $df_buf[5] );
				/*if( hide_mount( $df_buf[5] ) ) {
					continue;
				}*/
				$df_buf[0] = trim( str_replace("\$", "\\$", $df_buf[0] ) );
				$current = 0;
				foreach( $mount as $mount_line ) {
					if ( preg_match("#" . $df_buf[0] . " on " . $df_buf[5] . " type (.*) \((.*)\)#", $mount_line, $mount_buf) ) {
						$mount_buf[1] .= "," . $mount_buf[2];
					} elseif ( !preg_match("#" . $df_buf[0] . "(.*) on " . $df_buf[5] . " \((.*)\)#", $mount_line, $mount_buf) ) {
						continue;
					}
					$strFstype = substr( $mount_buf[1], 0, strpos( $mount_buf[1], "," ) );
					/*if( hide_fstype( $strFstype ) ) {
						continue;
					}*/
					$current++;
					if( $show_bind || !stristr($mount_buf[2], "bind")) {
						$results[$j] = array();
						$results[$j]['disk'] = str_replace( "\\$", "\$", $df_buf[0] );
						$results[$j]['size'] = $df_buf[1];
						$results[$j]['used'] = $df_buf[2];
						$results[$j]['free'] = $df_buf[3];
						// --> Bug 1527673
						if( $results[$j]['used'] < 0 ) {
							$results[$j]['size'] = $results[$j]['free'];
							$results[$j]['free'] = 0;
							$results[$j]['used'] = $results[$j]['size'];
						}
						// <-- Bug 1527673
						// --> Bug 1649430
						if( $results[$j]['size'] == 0 ) {
							break;
						} else {
							$results[$j]['percent'] = round(($results[$j]['used'] * 100) / $results[$j]['size']);
						}
						// <-- Bug 1649430
						$results[$j]['mount'] = $df_buf[5];
						$results[$j]['fstype'] = $strFstype;
						$results[$j]['options'] = substr( $mount_buf[1], strpos( $mount_buf[1], "," ) + 1, strlen( $mount_buf[1] ) );
						if( $show_inodes && isset($inode_buf[ count( $inode_buf ) - 1][1]) ) {
							$results[$j]['inodes'] = $inode_buf[ count( $inode_buf ) - 1][1];
						}
						$j++;
						unset( $mount[$current - 1] );
						sort( $mount );
						break;
					}
				}
			}
		}
		return $results;
	}
	
}

function rfts( $strFileName, $intLines = 0, $intBytes = 4096, $booErrorRep = true ) {

	$strFile = "";
	$intCurLine = 1;
  
	if( file_exists( $strFileName ) ) {
		if( $fd = fopen( $strFileName, 'r' ) ) {
			while( !feof( $fd ) ) {
				$strFile .= fgets( $fd, $intBytes );
				if( $intLines <= $intCurLine && $intLines != 0 ) {
					break;
				} else {
					$intCurLine++;
				}
			}
			fclose( $fd );
		} else {
			if( $booErrorRep ) {
				error_log( 'fopen(' . $strFileName . ') : file can not read' );
			}
			return "ERROR";
		}
	} else {
		if( $booErrorRep ) {
			error_log( 'file_exists(' . $strFileName . ') : the file does not exist on your machine' );
		}
		return "ERROR";
	}
	
	return $strFile;
}

// Find a system program.  Do path checking
function find_program ($strProgram) {
	global $addpaths;
	
	$arrPath = array( '/bin', '/sbin', '/usr/bin', '/usr/sbin', '/usr/local/bin', '/usr/local/sbin' );
	if( isset( $addpaths ) && is_array( $addpaths ) ) {
		$arrPath = array_merge( $arrPath, $addpaths );
	}
	if ( function_exists( "is_executable" ) ) {
		foreach ( $arrPath as $strPath ) {
			$strProgrammpath = $strPath . "/" . $strProgram;
			if( is_executable( $strProgrammpath ) ) {
				return $strProgrammpath;
			}
		}
	} else {
		return strpos( $strProgram, '.exe' );
	}
}

// Execute a system program. return a trim()'d result.
// does very crude pipe checking.  you need ' | ' for it to work
// ie $program = execute_program('netstat', '-anp | grep LIST');
// NOT $program = execute_program('netstat', '-anp|grep LIST');
function execute_program ($strProgramname, $strArgs = '', $booErrorRep = true ) {

	$strBuffer = '';
	$strError = '';
	
	$strProgram = find_program($strProgramname);
	if ( ! $strProgram ) {
		if( $booErrorRep ) {
			error_log( 'find_program(' . $strProgramname . ') : program not found on the machine');
		}
		return "ERROR";
	}
	// see if we've gotten a |, if we have we need to do patch checking on the cmd
	if( $strArgs ) {
		$arrArgs = split( ' ', $strArgs );
		for( $i = 0; $i < count( $arrArgs ); $i++ ) {
			if ( $arrArgs[$i] == '|' ) {
				$strCmd = $arrArgs[$i + 1];
				$strNewcmd = find_program( $strCmd );
				$strArgs = ereg_replace( "\| " . $strCmd, "| " . $strNewcmd, $strArgs );
			}
		}
	}
	// no proc_open() below php 4.3
	if( function_exists( 'proc_open' ) ) {
		$descriptorspec = array(
			0 => array("pipe", "r"),  // stdin is a pipe that the child will read from
			1 => array("pipe", "w"),  // stdout is a pipe that the child will write to
			2 => array("pipe", "w")   // stderr is a pipe that the child will write to
		);
		$process = proc_open( $strProgram . " " . $strArgs, $descriptorspec, $pipes );
		if( is_resource( $process ) ) {
			while( !feof( $pipes[1] ) ) {
				$strBuffer .= fgets( $pipes[1], 1024 );
			}
			fclose( $pipes[1] );
			while( !feof( $pipes[2] ) ) {
				$strError .= fgets( $pipes[2], 1024 );
			}
			fclose( $pipes[2] );
		}
		$return_value = proc_close( $process );
	} else {
		if( $fp = popen( "(" . $strProgram . " " . $strArgs . " > /dev/null) 3>&1 1>&2 2>&3", 'r' ) ) {
			while( ! feof( $fp ) ) {
				$strError .= fgets( $fp, 4096 );
			}
			pclose( $fp );
		}
		$strError = trim( $strError );
		if( $fp = popen( $strProgram . " " . $strArgs, 'r' ) ) {
			while( ! feof( $fp ) ) {
				$strBuffer .= fgets( $fp, 4096 );
			}
			$return_value = pclose( $fp );
		}
	}

	$strError = trim( $strError );
	$strBuffer = trim( $strBuffer );
	
	if( ! empty( $strError ) || $return_value <> 0 ) {
		if( $booErrorRep ) {
			error_log( $strProgram .':'. $strError . "\nReturn value: " . $return_value);
		}
	}
	return $strBuffer;
}

?>

